function brf = train_brf(ferns, tr_data, nr_weak)

% Ķ͵
eps      = 1E-3;  % epsilon
nr_fern  = size(ferns, 1);   % ü Fern 
nr_feat  = size(ferns, 2);   %  Fern feature 
nr_bins  = 2^nr_feat;        % num. histogram bins

% н  
nr_tr = size(tr_data,1);
% н  
labels = tr_data(:, 3)';
%  н  weight ʱ⿣ evenϰ ش.
weights = (1/nr_tr)*ones(1, nr_tr);

% ʱȭ
weak_learners   = zeros(nr_weak, nr_feat, 2);   % weak classifiers (WCs) data
indexes         = zeros(1,nr_weak);             % weak clasifiers indxes -chosen ferns-
ratHstms        = zeros(nr_weak, nr_bins);      % ratio of weak classifiers probabilities
fernOutputs     = zeros(nr_tr,nr_fern);         % fern outputs on the input samples
for k = 1:nr_tr
    %  н Ϳ شϴ fern output Ѵ.
    fernOutputs(k,:) = get_fern(ferns, tr_data(k,:));
end

% ν Ѵ.
for i = 1:nr_weak
    %  weak learner  нŲ.
    
    % variables
    conf    = zeros(1, nr_tr);    % weak classifier confidence
    sel_fern_index   = 0;         % selected fern index
    maxDst  = inf;                % max. distance between class distributions
    ratHstm = zeros(1, nr_bins);  % ratio of class probabilities
    
    % nr_fern  fern ߿   .
    for j = 1:nr_fern
        % j° fern ؼ
        % weak classifier probabilities
        posHstm = zeros(1, nr_bins);  % for the positive class
        negHstm = zeros(1, nr_bins);  % for the negative class
        
        % compute weak classifier probabilities
        for k = 1:nr_tr
            %  k° н Ϳ ؼ
            label = labels(k);
            % k° н  j° fern ouput Ѵ.
            z = fernOutputs(k, j);
            % k° н  weight ̿ؼ  z output ׷ Ѵ.
            if (label==+1), posHstm(z) = posHstm(z) + weights(k); end
            if (label==-1), negHstm(z) = negHstm(z) + weights(k); end
        end
        
        % ׷ normalizeѴ.
        posHstm = posHstm./sum(posHstm(:));
        negHstm = negHstm./sum(negHstm(:));
        
        %  ׷  Ÿ Ÿ Ÿ ̿ؼ Ѵ.
        bat_dist = 2*sum(sqrt((posHstm.*negHstm)),2);
        
        % best weak classifier: the weak classifier that reduces best the
        % Battacharyya distance and that the chosen fern is not repeated.
        if (bat_dist < maxDst) && (sum(j==indexes,2)==0)
            %    ߿ bat_dist   weak learner .
            sel_fern_index = j;      % selected fern index
            maxDst  = bat_dist;     % max. distance
            % log. ratio of class probabilities
            ratHstm = 0.5*log((posHstm + eps)./(negHstm + eps));
        end
    end
    
    %  ó
    if (maxDst==inf), fun_messages('weak classifier not found ','error'); end
    %  н  Confidence Ѵ.
    %   weak learner ̿ؼ 󸶳  ߴ  ̴.
    for k = 1:nr_tr
        %  н Ϳ ؼ
        z       = fernOutputs(k, sel_fern_index); %   fern k° н  output
        conf(k) = ratHstm(1, z); % confidence log. ratio of class probabilities ´.
    end
    
    % Confidence ̿ؼ  н  weight Ѵ. (  histogram  )
    weights = weights.*exp(-1*labels.*conf);
    % Weight ߿ ʹ ū  trim Ų.
    weights = min(weights, 10/nr_tr);
    % weights sum to 1 ǰ Ѵ. (׷ )
    weights = weights./(sum(weights(:)));
    %  ° fern weak learner  Ѵ.
    indexes(i) = sel_fern_index;
    % Ѵ.
    weak_learners(i, :, :) = ferns(sel_fern_index, :, :);  % weak classifier data
    ratHstms(i,:) = ratHstm;  % weak classifier probability -ratio-
end

% classifier: boosted random ferns
clfr.WCs   = weak_learners;  % weak classifiers (WCs) data -selected ferns-
clfr.hstms = ratHstms;  % weak classifiers (WCs) probabilities -log. ratio-
clfr.ferns = ferns;  % random ferns -pool of random ferns-

% output
brf = clfr;
end
